{% extends "base.html" %}
{% load static %}

{% block title %} Edit WP {% endblock %}
{% block titleHeader %} Edit : {{wp.title}} {% endblock %}

{% block titleSubHeader %}
{{wp.subTitle}}
{% endblock %}

{% block libraries %}
<script src="https://cdn.jsdelivr.net/npm/editorjs-html@3.0.3/build/edjsHTML.js"></script>

<script src="{% static 'js/jquery.autocomplete.js' %}"></script>
<script src="{% static 'js/editorjs.js' %}"></script>
<script src="https://cdn.jsdelivr.net/npm/codex.editor.header@2.0.4/dist/bundle.js"></script>
<script src="https://cdn.jsdelivr.net/npm/@editorjs/header@latest"></script><!-- Header -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/simple-image@latest"></script><!-- Image -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/delimiter@latest"></script><!-- Delimiter -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/list@latest"></script><!-- List -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/checklist@latest"></script><!-- Checklist -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/quote@latest"></script><!-- Quote -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/code@latest"></script><!-- Code -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/embed@latest"></script><!-- Embed -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/table@latest"></script><!-- Table -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/link@latest"></script><!-- Link -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/warning@latest"></script><!-- Warning -->

<script src="https://cdn.jsdelivr.net/npm/@editorjs/marker@latest"></script><!-- Marker -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/inline-code@latest"></script><!-- Inline Code -->
{% endblock %}



{% block content %}


<div class="container">
    {% if request.user.is_staff %}
    {% if message_saved %}
        <div class="alert alert-success alert-dismissible fade show" role="alert">
          {{ message_saved }}
          <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
        </div>
    {% endif %}


    <form id="wp_edit_form" method="POST">
    {% csrf_token %}
    <h1>Title</h1>
    <input type="text" class="form-control" id="wp_title"
           name="wp_title" value="{{wp.title}}"
           onkeyup="stoppedTyping_wp()">

    <h1>Sub title</h1>
    <input type="text" class="form-control" id="wp_subTitle"
           name="wp_subTitle" value="{{wp.subTitle}}"
           onkeyup="stoppedTyping_wp()">

    <h1>Content</h1>
    <div id="editorjs"></div>
    <input id="editorjs_content" name="editorjs_content" type="hidden"
           value="">

    <div class="d-grid gap-2 d-md-flex justify-content-md-end mt-3 me-2">
        <a type="button" class="btn btn-danger" href="{% url 'home_page' %}">
            <i class="fas fa-times"></i> Cancel
        </a>
        <button type="submit" class="btn btn-primary"
                id="submit_wp" name="edit_wp"
                >
            <i class="fas fa-pen"></i> Edit
        </button>
    </div>

    </form>
    {% endif %}
</div>

<script>

  function stoppedTyping(){
        var l = document.getElementById('cat_name').value.length ;
        if(l > 0 ) {
            $("#submit_cat").prop("disabled", false);
        } else {
            $("#submit_cat").prop("disabled", true);
        }
  }


  // EDITOR JS
        var content_dim = 0
        var False = false;
        var True = true;

        var editor = new EditorJS({
          /**
           * Enable/Disable the read only mode
           */

          readOnly: false,

          /**
           * Wrapper of Editor
           */
          holder: 'editorjs',

          /**
           * Common Inline Toolbar settings
           * - if true (or not specified), the order from 'tool' property will be used
           * - if an array of tool names, this order will be used
           */
           inlineToolbar: ['link', 'marker', 'bold', 'italic'],
           inlineToolbar: true,

          /**
           * Tools list
           */
          tools: {
            /**
             * Each Tool is a Plugin. Pass them via 'class' option with necessary settings {@link docs/tools.md}
             */
            header: {
              class: Header,
              inlineToolbar: ['marker', 'link'],
              config: {
                placeholder: 'Header'
              },
              shortcut: 'CMD+SHIFT+H'
            },

            /**
             * Or pass class directly without any configuration
             */
            image: SimpleImage,

            list: {
              class: List,
              inlineToolbar: true,
              shortcut: 'CMD+SHIFT+L'
            },

            checklist: {
              class: Checklist,
              inlineToolbar: true,
            },

            quote: {
              class: Quote,
              inlineToolbar: true,
              config: {
                quotePlaceholder: 'Enter a quote',
                captionPlaceholder: 'Quote\'s author',
              },
              shortcut: 'CMD+SHIFT+O'
            },

            warning: Warning,

            marker: {
              class:  Marker,
              shortcut: 'CMD+SHIFT+M'
            },

            code: {
              class:  CodeTool,
              shortcut: 'CMD+SHIFT+C'
            },

            delimiter: Delimiter,

            inlineCode: {
              class: InlineCode,
              shortcut: 'CMD+SHIFT+C'
            },

            linkTool: LinkTool,

            embed: {
              class: Embed,
              inlineToolbar: true,
            },

            table: {
              class: Table,
              inlineToolbar: true,
              shortcut: 'CMD+ALT+T'
            },

          },


          /**
           * Initial Editor data
           */

           data: {{wp.content | safe }} ,

          onReady: function(){
            editor.save()
            .then((savedData) => {
                document.getElementById("editorjs_content").value = JSON.stringify(savedData);
                content_dim = savedData["blocks"].length;
            })
            .catch((error) => {
              document.getElementById("check").innerHTML="Error";
                 setTimeout(function(){
                 document.getElementById("check").innerHTML="";
                 },3000);
            });
          },
          onChange: function() {
            editor.save()
            .then((savedData) => {
                document.getElementById("editorjs_content").value = JSON.stringify(savedData);
                content_dim = savedData["blocks"].length;
                var t = document.getElementById('wp_title').value.length ;
                var st = document.getElementById('wp_subTitle').value.length ;
                if(t > 0 && st > 0 && content_dim >0) {
                    $("#submit_wp").prop("disabled", false);
                } else {
                    $("#submit_wp").prop("disabled", true);
                }
            })
            .catch((error) => {
              document.getElementById("check").innerHTML="Error";
                 setTimeout(function(){
                 document.getElementById("check").innerHTML="";
                 },3000);
            });
          }
        });

      function stoppedTyping_wp(){
        var t = document.getElementById('wp_title').value.length ;
        var st = document.getElementById('wp_subTitle').value.length ;
        if(t > 0 && st > 0 && content_dim >0) {
            $("#submit_wp").prop("disabled", false);
        } else {
            $("#submit_wp").prop("disabled", true);
        }
      }

</script>
{% endblock %}